import java.io.*;
import java.net.*;

public class Slave
{ Tabella tabella;
  String master;
  
  public Slave(Tabella tabella,String master)
  {this.tabella=tabella;
   this.master=master;
  }
  
  //thread che si occupa di inviare la tabella ad ogni richiesta
  //ovvero ad ogni nuovo avvio del Name Server
  public class InviaTabella extends Thread
  { 
   public void run()
   {try{
    ServerSocket server=new ServerSocket(2003); 
    for(;;)
    {System.out.println("Thread InviaTabella in attesa di WakeUp del MASTER...");
     Socket master=server.accept();//aspetta richiesta
     OutputStream o=master.getOutputStream();
     BufferedOutputStream buf=new BufferedOutputStream(o); 
     DataOutputStream doStream=new DataOutputStream(buf);
     for(int i=0;i<Tabella.NUM;i++)
      {
       Entry entry=tabella.getByIndex(i);
       if(entry.getFilename().equals(""))continue;
       doStream.writeUTF("100"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
       doStream.writeUTF("$");
      }
     buf.flush();
     master.close();
    }//fine for
    
    }catch(Exception e)
    {
     e.printStackTrace();
    }


   }//fine run()

   

  }//fine InviaTabella

  
  public void gestoreTabella()
  {try
   {    new InviaTabella().start(); //un thread che invia la tabella su richiesta
  
        InetAddress inet=InetAddress.getLocalHost(); 
        InetAddress inetAddress = InetAddress.getByName("lia22");		 
	DatagramSocket dSocket=new DatagramSocket(2003,InetAddress.getLocalHost());
   
    System.out.println("SLAVE avviato..."); 
    for(;;){//ciclo del server
	  byte buffer[]=new byte[65536];
	  DatagramPacket rPacket= new DatagramPacket(buffer,buffer.length);
	  ByteArrayOutputStream boStream=new ByteArrayOutputStream(); //crea stream per pacchetti
      DataOutputStream doStream=new DataOutputStream(boStream);	 
	  
	  dSocket.receive(rPacket);
		 
	  Estrai estrai=new Estrai(rPacket);     
	  EntryCommand entryC=estrai.estraiDati();
		 
	  if (entryC.getCommand().equals("400")) //invia tutta la tabella e si rimette in ascolto
	  {System.out.println("400, invio tabella");
	   for(int i=0;i<Tabella.NUM;i++)
	   {
        Entry entry=tabella.getByIndex(i);
	    if(entry.getFilename().equals(""))continue;
		
	    doStream.writeUTF("100"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
		byte data[]= boStream.toByteArray();
	    DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2002);
	    dSocket.send(dPacket);
	    System.out.println("ho spedito entry");
		boStream.reset(); 			
 	   }
	   Thread.sleep(2000);//aspetto per assicurarmi che i pacchetti siano arrivati(quasi tutti)
	   boStream.reset();
	   doStream.writeUTF("500"+"&"+"campo2"+"&"+"campo3"+"&");
	   byte data[]=boStream.toByteArray();
	  
	   DatagramPacket dPacket= new DatagramPacket(data,data.length,inetAddress,2002);
	   dSocket.send(dPacket);
	   System.out.println("ho spedito fine tabella"); 
      }
	  //--------------
	  else if(entryC.getCommand().equals("100"))	//inserisco il nome in tabella
	  {
	  
	   Entry entrytemp=tabella.getByFilename(entryC.getFilename());
	   //se il nome non  presente entry conterr stringhe nulle
	   if (entrytemp.getFilename().equals(""))
	   {
	    tabella.insert(new Entry(entryC.getHost(),entryC.getFilename()));
	    System.out.println("inserito elemento");
	   }
	  }
	  //--------------	  
	  else if(entryC.getCommand().equals("300")) //comando di eliminazione
	  {
		//bisogna prima controllare se c' un file con quel nome
		Entry entry=tabella.getByFilename(entryC.getFilename());
	    if(entry.getFilename().equals(entryC.getFilename()))//se il nome  presente...
		 {
		  if (entry.getHost().equals(entryC.getHost()))//se l'host corrisponde
		   {System.out.println("il file  presente"); 
			tabella.removeByFilename(entryC.getFilename()); //...lo rimuovo...
		   }
		 }
	  } 
	
	}//fine for
  }catch(UnknownHostException e)
  {e.printStackTrace();
  }catch(IOException e)
  {e.printStackTrace();
  }catch(InterruptedException e)
  {e.printStackTrace();
  }
 }

  
  public static void main(String args[])
  {
   Tabella tabella=new Tabella();
   Slave slave=new Slave(tabella,args[0]);
   slave.gestoreTabella();	 	
  }

}


//**********************************

class Entry
{protected String host;
 protected String nomefile;
 protected int time;
 public Entry(String host,String nomefile)
 {this.host=host;
  this.nomefile=nomefile;
  this.time=0;
  }
 public Entry()
 {this.time=0;
 }
  
 public String getHost()
 {return(host);
 }
 public String getFilename()
 {return(nomefile);
 }
 public int getTime()
 {
  return(time);
 }
 public void setTime(int time)
 {this.time=time;
 }
}


//*******************************



class EntryCommand extends Entry
{protected String command;
 public EntryCommand(String command,String host,String nomefile)
 {super(host,nomefile);
  this.command=command;
 }
 public String getCommand()
 {return(command);
 }
}

//******************************

class Estrai
{ protected DatagramPacket packet; 
  public Estrai(DatagramPacket packet)
  {this.packet=packet;
  }
  public EntryCommand estraiDati() throws IOException
  {       
             ByteArrayInputStream biStream=new ByteArrayInputStream(packet.getData(),0,
		                                              packet.getLength());
		     DataInputStream diStream=new DataInputStream(biStream); 
			 
             String message = diStream.readUTF();
			 
			  //il messaggio viene interpretato
			 char tochar[]=message.toCharArray();
			 int i=0;
	  
             StringBuffer command=new StringBuffer();
	         StringBuffer host=new StringBuffer();
	         StringBuffer nome=new StringBuffer();
	  
	         while (tochar[i]!='&')
	         { 
	  	       command=command.append(tochar[i]);
			   i++;
	         }
		     i++;
				
	         while (tochar[i]!='&')
	         { 
	  	       host=host.append(tochar[i]);
			   i++;
	         } 
	         i++;
				
	         while (tochar[i]!='&')
	         {  
	  	        nome=nome.append(tochar[i]);
				i++;
	         }

             EntryCommand entry=new EntryCommand(command.toString(),host.toString(),
			 		                  nome.toString());
				  
			 return(entry);
            
			
  }
}


//********************

class Tabella
{ public static int NUM=1000; 
  Entry tabella[]=new Entry[NUM];
  boolean full[]=new boolean[NUM];
  
  public Tabella()
  {for(int i=0;i<NUM;i++)full[i]=false;
   for(int i=0;i<NUM;i++)tabella[i]=new Entry("","");
  }
  
  synchronized public Entry getByIndex(int i)
  {return(tabella[i]);
  }
  
  synchronized public void insert(Entry entry)
  {int i;
   for(i=0;full[i]==true;i++);
   tabella[i]=entry;
   full[i]=true;
  }
  
  synchronized public Entry getByFilename(String nomefile) 
  {for(int i=0;i<NUM;i++)
  	 if(tabella[i].getFilename().equals(nomefile))return(tabella[i]);
   return(new Entry("","")); 
  }
  
  synchronized public Entry getByFilenameTozero(String nomefile)
  {Entry entry = new Entry();
   entry = this.getByFilename(nomefile);
   this.removeByFilename(entry.getFilename());
   int time = entry.getTime();
   entry.setTime(0);      //si richiede una entry della tabella ad uso di un client
   this.insert(entry);    //quindi bisogna azzerare il campo time
   entry.setTime(time);
   return(entry);
  }
  
  synchronized public Entry getByIndexT(int position,int maxTime)
  {Entry entry=new Entry();
   entry=this.getByIndex(position);    //restituisce al thread la entry di indice position
   int time=entry.getTime();           //ed incrementa il tempo di vita della entry
   if (time<=maxTime)                  //se non  pi vecchia di maxTime, altrimenti 
   {                                   //la rimuove dalla tabella
    entry.setTime(time+1);
    this.removeByFilename(entry.getFilename());
    this.insert(entry);
	entry.setTime(time);
	return(entry);
   }
   else 
   {this.removeByFilename(entry.getFilename());
    return(entry);
   }
  }
	 
  
  synchronized public void removeByFilename(String nomefile)
  {int i;
   for(i=0;i<NUM;i++)
  	 if (tabella[i].getFilename().equals(nomefile))
	 {tabella[i]=new Entry("","");
	  full[i]=false; 
	  return;
	 }
  }
}
  

//********************


/*------------------------  
   
   InetAddress inetAddress=InetAddress.getLocalHost();
   DatagramSocket dSocket=new DatagramSocket(2003,inetAddress);//porta e ind. locali
	
   ByteArrayOutputStream boStream=new ByteArrayOutputStream(); //crea stream per pacchetti
   DataOutputStream doStream=new DataOutputStream(boStream);
   byte buf[]=new byte[65535];
   DatagramPacket rPacket= new DatagramPacket(buf,buf.length);
       
   dSocket.receive(rPacket);	
	 
   Estrai estrai=new Estrai(rPacket);
   EntryCommand entryC=estrai.estraiDati();
   System.out.println("ricevuta richiesta"); 
   for(;;)
   {ByteArrayOutputStream bStream=new ByteArrayOutputStream(); //crea stream per pacchetti
    DataOutputStream dStream=new DataOutputStream(bStream);
    byte datap[]= bStream.toByteArray();
    if (entryC.getCommand().equals("400")) //se 400 invia tutta la tabella e si rimette in ascolto
	{System.out.println("400, invio tabella");
	 for(int i=0;i<Tabella.NUM;i++)
	  {
       Entry entry=tabella.getByIndex(i);
	   if(entry.getFilename().equals(""))continue;
	   dStream.writeUTF("100"+"&"+entry.getHost()+"&"+entry.getFilename()+"&");
	   DatagramPacket dPacket= new DatagramPacket(datap,datap.length,inetAddress,2002);
	   dSocket.send(dPacket);
	   System.out.println("ho spedito entry"); 			
 	  }
	 Thread.sleep(2000);//aspetto per assicurarmi che i pacchetti siano arrivati(quasi tutti)
	 dStream.writeUTF("500"+"&"+"campo2"+"&"+"campo3"+"&");
	 DatagramPacket dPacket= new DatagramPacket(datap,datap.length,inetAddress,2002);
	 dSocket.send(dPacket);
	 System.out.println("ho spedito fine tabella"); 
    }
	else if (entryC.getCommand().equals("100"))	//inserisco il nome in tabella
	{tabella.insert(new Entry(entryC.getHost(),entryC.getFilename()));
	 System.out.println("inserito elemento");
	}
		
	dSocket.setSoTimeout(0);
	dSocket.receive(rPacket);
	System.out.println("prima");
	Estrai estrai1=new Estrai(rPacket);
    entryC=estrai1.estraiDati();
	System.out.println("dopo");*/